#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_cJIK72x0x72TN72x72x0_a1_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=72, NB=0, KB=72, 
 * lda=72, ldb=72, ldc=0, mu=3, nu=1, ku=24, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   #define Nb N
   const float *stM = A + 5184;
   const float *stN = B + (((Nb) << 6)+((Nb) << 3));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*3*1)/(72*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 24
   const int incAm = 144, incAn = -5184;
   #define incBk 24
   const int incBm = -72, incBn = 72;
   #define incCm 6
   const int incCn = (((ldc) << 1)) - 144;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2;
   register float rB0;
   register float rC0_0, rC1_0, rC2_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rC0_0 = *pC0;
         rC1_0 = pC0[2];
         rC2_0 = pC0[4];
         for (k=0; k < 3; k++) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA1 = pA0[72];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[144];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[73];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[145];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[74];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[146];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[75];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[147];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[76];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[148];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[77];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[149];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[78];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[150];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[79];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[151];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[80];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[152];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[81];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[153];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[82];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[154];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[83];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[155];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[84];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[156];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[85];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[157];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[86];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[158];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[87];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[159];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[88];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[160];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[89];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[161];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[90];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[162];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[19];
            rB0 = pB0[19];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[91];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[163];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[20];
            rB0 = pB0[20];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[92];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[164];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[21];
            rB0 = pB0[21];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[93];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[165];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[22];
            rB0 = pB0[22];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[94];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[166];
            rC2_0 += rA2 * rB0;
            rA0 = pA0[23];
            rB0 = pB0[23];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[95];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[167];
            rC2_0 += rA2 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANN
#define ATL_cpNBmm_b1 ATL_cgpNBmm_b1
#endif

void ATL_cJIK72x0x72TN72x72x0_a1_bX(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);
void ATL_cJIK72x0x72TN72x72x0_a1_bX(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);
void ATL_cJIK72x0x72TN72x72x0_a1_b1(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);

void ATL_cpNBmm_b1(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc)
{
   ATL_cJIK72x0x72TN72x72x0_a1_bX(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_cJIK72x0x72TN72x72x0_a1_bX(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_cJIK72x0x72TN72x72x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_cJIK72x0x72TN72x72x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
