#ifdef ATL_UCLEANN
#define ATL_sJIK60x0x60TN60x60x0_a1_bX ATL_sgpNBmm_bX
#else
#define ATL_sJIK60x0x60TN60x60x0_a1_bX ATL_spNBmm_bX
#endif

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_sJIK60x0x60TN60x60x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=60, NB=0, KB=60, 
 * lda=60, ldb=60, ldc=0, mu=6, nu=1, ku=20, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   #define Nb N
   const float *stM = A + 3600;
   const float *stN = B + (60*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*6*1)/(60*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 20
   const int incAm = 300, incAn = -3600;
   #define incBk 20
   const int incBm = -60, incBn = 60;
   #define incCm 6
   const int incCn = (ldc) - 60;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5;
   register float rB0;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[1];
         rC1_0 *= rA0;
         rC2_0 = pC0[2];
         rC2_0 *= rA0;
         rC3_0 = pC0[3];
         rC3_0 *= rA0;
         rC4_0 = pC0[4];
         rC4_0 *= rA0;
         rC5_0 = pC0[5];
         rC5_0 *= rA0;
         for (k=0; k < 3; k++) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[60];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[120];
            rA3 = pA0[180];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[240];
            rA5 = pA0[300];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[61];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[121];
            rA3 = pA0[181];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[241];
            rA5 = pA0[301];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[62];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[122];
            rA3 = pA0[182];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[242];
            rA5 = pA0[302];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[63];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[123];
            rA3 = pA0[183];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[243];
            rA5 = pA0[303];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[64];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[124];
            rA3 = pA0[184];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[244];
            rA5 = pA0[304];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[65];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[125];
            rA3 = pA0[185];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[245];
            rA5 = pA0[305];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[66];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[126];
            rA3 = pA0[186];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[246];
            rA5 = pA0[306];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rA1 = pA0[67];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[127];
            rA3 = pA0[187];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[247];
            rA5 = pA0[307];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rA1 = pA0[68];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[128];
            rA3 = pA0[188];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[248];
            rA5 = pA0[308];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rA1 = pA0[69];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[129];
            rA3 = pA0[189];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[249];
            rA5 = pA0[309];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rA1 = pA0[70];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[130];
            rA3 = pA0[190];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[250];
            rA5 = pA0[310];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rA1 = pA0[71];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[131];
            rA3 = pA0[191];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[251];
            rA5 = pA0[311];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rA1 = pA0[72];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[132];
            rA3 = pA0[192];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[252];
            rA5 = pA0[312];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rA1 = pA0[73];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[133];
            rA3 = pA0[193];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[253];
            rA5 = pA0[313];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rA1 = pA0[74];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[134];
            rA3 = pA0[194];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[254];
            rA5 = pA0[314];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rA1 = pA0[75];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[135];
            rA3 = pA0[195];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[255];
            rA5 = pA0[315];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rA1 = pA0[76];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[136];
            rA3 = pA0[196];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[256];
            rA5 = pA0[316];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rA1 = pA0[77];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[137];
            rA3 = pA0[197];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[257];
            rA5 = pA0[317];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rA1 = pA0[78];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[138];
            rA3 = pA0[198];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[258];
            rA5 = pA0[318];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[19];
            rB0 = pB0[19];
            rA1 = pA0[79];
            rC0_0 += rA0 * rB0;
            rA2 = pA0[139];
            rA3 = pA0[199];
            rC1_0 += rA1 * rB0;
            rA4 = pA0[259];
            rA5 = pA0[319];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0[4] = rC4_0;
         pC0[5] = rC5_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
